diff -urN linux.store/linux/arch/arm/drivers/block/mfmhd.c linux/arch/arm/drivers/block/mfmhd.c
--- linux.store/linux/arch/arm/drivers/block/mfmhd.c	Sun Mar  3 12:30:30 1996
+++ linux/arch/arm/drivers/block/mfmhd.c	Mon Mar 11 23:11:51 1996
@@ -1,11 +1,33 @@
 /*
  * linux/arch/arm/drivers/block/mfmhd.c
  *
- * Copyright (C) 1995, 1996 Russell King
+ * Copyright (C) 1995, 1996 Russell King, Dave Alan Gilbert (gilbertd@cs.man.ac.uk)
  *
  * MFM hard drive code [experimental]
  */
 
+/*
+ * Change list:
+ *
+ *  3/2/96:DAG: Started a change list :-)
+ *              Set the hardsect_size pointers up since we are running 256 byte
+ *                sectors
+ *              Added DMA code, put it into the rw_intr
+ *              Moved RCAL out of generic interrupt code - don't want to do it
+ *                while DMA'ing - its now in individual handlers.
+ *              Took interrupt handlers off task queue lists and called
+ *                directly - not sure of implications.
+ *
+ *  18/2/96:DAG: Well its reading OK I think, well enough for image file code
+ *              to find the image file; but now I've discovered that I actually
+ *              have to put some code in for image files.
+ *
+ *              Added stuff for image files; seems to work, but I've not
+ *              got a multisegment image file (I don't think!).
+ *              Put in a hack (yep a real hack) for multiple cylinder reads.
+ *              Not convinced its working.
+ */
+
 #ifdef MODULE
 #include <linux/module.h>
 #include <linux/version.h>
@@ -19,18 +41,34 @@
 #include <linux/tqueue.h>
 #include <linux/mm.h>
 
-#include <linux/xd.h>
 #include <linux/errno.h>
 #include <linux/genhd.h>
 #include <linux/major.h>
+#include <linux/xd.h>
 
 #include <asm/system.h>
 #include <asm/io.h>
+#include <asm/irq-no.h>
 #include <asm/segment.h>
+#include <asm/delay.h>
 #include <asm/dma.h>
 
 #include <asm/ecard.h>
 
+#define MAX_FRAGS          16
+static unsigned long frag_start[MAX_FRAGS];        /* start of fragments */
+static unsigned long frag_len[MAX_FRAGS];          /* Fragment length */
+static int frag_count;                             /* Number of fragments to go */
+static int frag_pos;                               /* Position in fragment arrays */
+static unsigned int frag_sectors;
+
+static unsigned int PartFragRead;   /* The number of sectors which have been read
+                                       during a partial read split over two
+                                       cylinders.  If 0 it means a partial
+                                       read did not occur. */
+
+static unsigned int PartFragRead_RestartBlock; /* Where to restart on a split access */
+static unsigned int PartFragRead_SectorsLeft; /* Where to restart on a split access */
 #define MFM_DISK_MAJOR	13
 #undef  XT_DISK_MAJOR
 #define XT_DISK_MAJOR	-1
@@ -39,14 +77,14 @@
 
 XD_INFO mfm_info[XD_MAXDRIVES];
 
-#define DEBUG
+/*#define DEBUG */
 
 #define MFM_COMMAND (mfm_addr + 0)
 #define MFM_DATAOUT (mfm_addr + 1)
 #define MFM_STATUS  (mfm_addr + 8)
 #define MFM_DATAIN  (mfm_addr + 9)
 
-static void mfm_geninit (void);
+static void mfm_geninit (struct gendisk *dev);
 static int  mfm_ioctl (struct inode *inode,struct file *file,u_int cmd,u_long arg);
 static int  mfm_open (struct inode *inode,struct file *file);
 static void mfm_release (struct inode *inode, struct file *file);
@@ -56,8 +94,10 @@
 static void mfm_request (void);
 static int  mfm_reread_partitions (int dev);
 static void mfm_request (void);
+static void mfm_specify (void);
 
 #define mfm_init xd_init
+#define mfm_setup xd_setup
 
 static struct hd_struct mfm[XD_MAXDRIVES << 6];
 static int mfm_sizes[XD_MAXDRIVES << 6], mfm_access[XD_MAXDRIVES] = { 0, 0 };
@@ -67,6 +107,8 @@
 
 static int mfm_irq;		/* Interrupt number */
 static int mfm_addr;		/* Controller address */
+static unsigned char *mfm_IRQPollLoc;  /* Address to read for IRQ information */
+static char mfm_IRQMask;    /* AND with *mfm_IRQPollLoc to find if there is an interrupt */
 static int mfm_drives = 0;	/* drives available */
 static int mfm_status = 0;	/* interrupt status */
 static char mfm_busy = 0;	/* mfm busy */
@@ -132,7 +174,16 @@
 #define NEED_1_RECAL -2
 #define NEED_2_RECAL -3
 
+int mfm_sectsizes[256]; /* We have to do this because we don't have 512 byte sectors */
 
+/* Stuff from the assembly routines */
+extern unsigned int hdc63463_baseaddress;    /* Controller base address */
+extern unsigned int hdc63463_irqpolladdress; /* Address to read to test for int */
+extern unsigned int hdc63463_irqpollmask;    /* Mask for irq register */
+extern unsigned int hdc63463_dataptr;        /* Pointer to kernel data space to DMA */
+extern int hdc63463_dataleft;                /* Number of bytes left to transfer */
+
+extern unsigned char *ioc;
 /* ------------------------------------------------------------------------------------------ */
 /*
  * From the HD63463 data sheet from Hitachi Ltd.
@@ -204,43 +255,105 @@
 static int mfm_prods[] = { 0x000b };
 static int mfm_manus[] = { 0x0000 };
 
-unsigned long mfm_init (unsigned long mem_start, unsigned long mem_end)
+int mfm_init (void)
 {
+  unsigned int i;
+/* DAG */
+#ifdef CONFIG_MFM_ONMAINBOARD
+  mfm_irq = IRQ_HARDDISK;
+  mfm_addr=(0x3250000>>2); /* Motherboard HDC address  - thats probably slow - what should it be? */
+  mfm_IRQPollLoc=ioc+0x20;
+  mfm_IRQMask=0x08; /* IL3 pin */
+#else
 	ecs = ecard_find(0, sizeof(mfm_prods), mfm_prods, mfm_manus);
 	if(!ecs)
-		return mem_start;
+		return -1;
 
 	mfm_irq = ecs->irq;
 	mfm_addr= ((((int)ecs->r_podaddr) & 0x03eff000) + 0x2000)>>2;
 
+  /* DAG: Temporary until I examine a podule a bit */
+  printk("mfm_init: Sorry podule based MFM cards aren't supported - need IRQ poll loc and mask\n");
+  return -1;
+
+
 	ecard_claim(ecs);
+#endif
 
-	printk("mfm: controller found at address %X, interrupt %d\n", mfm_addr, mfm_irq);
+  /* Stuff for the assembler routines to get to */
+  hdc63463_baseaddress=(unsigned int)(mfm_addr<<2);
+  hdc63463_irqpolladdress=(int)mfm_IRQPollLoc;
+  hdc63463_irqpollmask=mfm_IRQMask;
+
+	printk("mfm: controller found at address %X, interrupt %d\n", mfm_addr<<2, mfm_irq);
 
 	if(register_blkdev(MAJOR_NR, "mfm", &mfm_fops)) {
 		printk("mfm_init: unable to get major number %d\n", MAJOR_NR);
-		return mem_start;
+		return -1;
 	}
 	blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
-	read_ahead[MAJOR_NR] = 8; /* 8 sector (4kB) read ahread */
+	read_ahead[MAJOR_NR] = 8; /* 8 sector (4kB?) read ahread */
+
+  /* This stops MSDOS trying to mount it - but ll_rw_blk has tons of >>9
+     presuming 512 byte sectors - its upto us to fix it! */
+  hardsect_size[MAJOR_NR]=mfm_sectsizes;
+  for(i=0;i<256;i++)
+    mfm_sectsizes[i]=256;
+
 #ifndef MODULE
 	mfm_gendisk.next = gendisk_head;
 	gendisk_head = & mfm_gendisk;
 #endif
 
-	return mem_start;
+	return 0;
 }
 
+/* DAG: Gets called by the genhd code to set up the number of sectors etc. */
+void xt_set_geometry(int dev,unsigned char secsptrack,unsigned char heads,
+                   unsigned long discsize, unsigned int secsize)
+{
+  dev=MINOR(dev);
+  /* The HD version checks to see if the number of cylinders are unset */
+  /* and then causes them to be set... */
+  /* Need to set up the precomp etc. */
+  if (mfm_info[dev>>6].cylinders==1)
+  {
+    mfm_info[dev>>6].sectors=secsptrack;
+    mfm_info[dev>>6].heads=heads;
+    mfm_info[dev>>6].cylinders=discsize/(secsptrack*heads*secsize);
+
+    mfm_drive_param[dev>>6].nosectors=secsptrack;
+    mfm_drive_param[dev>>6].noheads=heads;
+    mfm_drive_param[dev>>6].nocylinders=discsize/(secsptrack*heads*secsize);
+
+    printk("mfm%c: %d cylinders, %d heads, %d sectors secsize=%d (%ld total)\n",'a'+(dev>>6),
+        mfm_info[dev>>6].cylinders, heads, secsptrack, secsize, discsize);
+    /* Should probably do a specify command here....*/
+    printk("mfm: at end of set_hdinfo: About to do a specify\n");
+    if ((heads<1) || (mfm_drive_param[dev>>6].nocylinders>1024)) {
+      /* Shouldn't be a panic - but easiest for initial debug */
+      panic("xt_set_hdinfo: Invalid heads/cylinders count\n"); 
+    };
+    mfm_specify();
+    printk("mfm: set_hdinfo after the specify\n");
+  };
+
+  mfm[dev].start_sect=0;
+  mfm[dev].nr_sects=(discsize/secsize)/2; /* This is 512 byte sectors - I want 256 but where does this get set for image files? */
+  printk("mfm set_hdinfo: mfm[%d].nr_sects=%ld\n",dev,mfm[dev].nr_sects);
+
+}
+    
 static int mfm_initdrives (void)
 {
 	mfm_info[0].heads = 4;
-	mfm_info[0].cylinders = 615;
+	mfm_info[0].cylinders = 1; /* its going to have to figure it out from the drive */
 	mfm_info[0].sectors = 32;
 	mfm_info[0].control = 0;
 	return 1;
 }
 
-static void mfm_geninit (void)
+static void mfm_geninit (struct gendisk *dev)
 {
 	int i;
 
@@ -250,11 +363,14 @@
 		printk("mfm%d: heads = %d, cylinders = %d, sectors = %d\n", i,
 			 mfm_info[i].heads, mfm_info[i].cylinders, mfm_info[i].sectors);
 
+  /*printk("mfm: Before irq register\n");*/
 	if(request_irq(mfm_irq, mfm_interrupt_handler, SA_INTERRUPT, "MFM harddisk"))
 		printk("mfm: unable to get IRQ%d\n", mfm_irq);
 
-	outw(0x80, mfm_addr + (0x1000 >> 2));
+  /*printk("mfm: Before wierd write\n"); */
+	/*outw(0x80, mfm_addr + (0x1000 >> 2)); *//* Pardon? DAG */
 
+  /*printk("mfm: Before data init\n");*/
 	for(i = 0; i < mfm_drives; i++) {
 		mfm[i << 6].nr_sects = mfm_info[i].heads * mfm_info[i].cylinders *
 				mfm_info[i].sectors;
@@ -263,16 +379,18 @@
 	}
 	mfm_gendisk.nr_real = mfm_drives;
 
+  /*printk("mfm: Before init blocksizes\n");*/
 	for(i=0; i<(XD_MAXDRIVES << 6); i++)
 		mfm_blocksizes[i] = 1024;
 	blksize_size[MAJOR_NR] = mfm_blocksizes;
+  /*printk("mfm: End of init\n");*/
 }
 
 static int mfm_open (struct inode *inode,struct file *file)
 {
 	int dev = DEVICE_NR(MINOR(inode->i_rdev));
 
-	if (dev < mfm_drives) {
+	if ((dev) < mfm_drives) {
 		while (!mfm_valid[dev])
 			sleep_on(&mfm_wait_open);
 
@@ -443,19 +561,27 @@
 	do {
 		status = inw(MFM_STATUS);
 	} while(status & (STAT_BSY|STAT_POL));
-	if(status & STAT_CPR)
+  /*printk("issue_command: status after pol/bsy loop: %02X:\n ",status>>8); */
+	if(status & (STAT_CPR|STAT_CED|STAT_SED|STAT_DER|STAT_ABN))
 	{
 		outw(CMD_RCAL, MFM_COMMAND);
 		while(inw(MFM_STATUS) & STAT_BSY);
 	}
 
+	status = inw(MFM_STATUS);
+  /*printk("issue_command: status before parameter issue: %02X:\n ",status>>8);*/
 	while(len > 0)
 	{
 		outw(cmdb[1] | (cmdb[0] << 8), MFM_DATAOUT);
 		len -= 2;
 		cmdb += 2;
 	}
+	status = inw(MFM_STATUS);
+  /*printk("issue_command: status before command issue: %02X:\n ",status>>8);*/
 	outw(command, MFM_COMMAND);
+	status = inw(MFM_STATUS);
+  /*printk("issue_command: status immediatly after command issue: %02X:\n ",status>>8);*/
+  udelay(20);
 }
 
 static void wait_for_completion (void)
@@ -467,17 +593,83 @@
 
 static void mfm_rw_intr (void)
 {
-	printk("mfm_rw_intr...\n");
-	if (cont)
-	{
-		cont->done(1);
-	}
-	mfm_request();
+#ifdef DEBUG
+	printk("mfm_rw_intr...dataleft=%d\n",hdc63463_dataleft);
+  print_status();
+#endif
+
+  if (mfm_status & (STAT_DER | STAT_ABN)) {
+    /* Something has gone wrong - lets try that again */
+    outw(CMD_RCAL, MFM_COMMAND);	/* Clear interrupt condition */
+    if (cont) {
+      cont->error();
+      cont->redo();
+    };
+    return;
+  };
+
+  /* OK so what ever happend its not an error, now I reckon we are left between
+     a choice of command end or some data which is ready to be collected */
+  /* I think we have to transfer data while the interrupt line is on and its
+     not any other type of interrupt */
+  if (CURRENT->cmd==WRITE) {
+    extern void hdc63463_writedma(void);
+    if ((hdc63463_dataleft<=0) && (!(mfm_status & STAT_CED))) {
+      printk("mfm_rw_intr: Apparent DMA write request when no more to DMA\n");
+      if (cont) {
+        cont->error();
+        cont->redo();
+      };
+      return;
+    };
+    hdc63463_writedma();
+  } else {
+    extern void hdc63463_readdma(void);
+    if ((hdc63463_dataleft<=0) && (!(mfm_status & STAT_CED))) {
+      printk("mfm_rw_intr: Apparent DMA read request when no more to DMA\n");
+      if (cont) {
+        cont->error();
+        cont->redo();
+      };
+      return;
+    };
+    /*printk("Going to try read dma..............status=0x%x\n",mfm_status); */
+    hdc63463_readdma();
+  }; /* Read */
+
+	mfm_status = inw(MFM_STATUS);
+  if (mfm_status & (STAT_DER | STAT_ABN)) {
+    /* Something has gone wrong - lets try that again */
+    if (cont) {
+      cont->error();
+      cont->redo();
+    };
+    return;
+  };
+
+  /* If end of command move on */
+  if (mfm_status & (STAT_CED)) {
+    outw(CMD_RCAL, MFM_COMMAND);	/* Clear interrupt condition */
+    /* End of command - trigger the next command */
+    if (cont)
+    {
+      cont->done(1);
+    }
+    /*mfm_request(); - DAG - took out because we might not have finished the whole command */
+#ifdef DEBUG
+    printk("mfm_rw_intr: returned from cont->done\n");
+#endif
+  } else {
+    /* Its going to generate another interrupt */
+    SET_INTR(mfm_rw_intr);
+  };
 }
 
 static void mfm_setup_rw (void)
 {
+#ifdef DEBUG
 	printk("setting up for rw...\n");
+#endif
 #if 1
 	SET_INTR(mfm_rw_intr);
 	issue_command(raw_cmd.cmdcode, raw_cmd.cmddata, raw_cmd.cmdlen);
@@ -492,8 +684,11 @@
 
 static void mfm_recal_intr (void)
 {
+#ifdef DEBUG
 	printk("recal intr - status = ");
 	print_status();
+#endif
+  outw(CMD_RCAL, MFM_COMMAND);	/* Clear interrupt condition */
 	if(mfm_status & (STAT_DER|STAT_ABN)) {
 		printk("recal failed\n");
 		MFM_DRV_PARAM.cylinder = NEED_2_RECAL;
@@ -504,12 +699,15 @@
 		}
 		return;
 	}
+  /* Thats seek end - we are finished */
 	if(mfm_status & STAT_SED) {
 		issue_command(CMD_POD, NULL, 0);
 		MFM_DRV_PARAM.cylinder = 0;
 		mfm_seek();
 		return;
 	}
+  /* Command end without seek end (see data sheet p.20) for parallel seek
+     - we have to send a POL command to wait for the seek */
 	if(mfm_status & STAT_CED) {
 		SET_INTR(mfm_recal_intr);
 		issue_command(CMD_POL, NULL, 0);
@@ -520,8 +718,11 @@
 
 static void mfm_seek_intr (void)
 {
+#ifdef DEBUG
 	printk("seek intr - status = ");
-	print_status();
+	print_status();  
+#endif
+  outw(CMD_RCAL, MFM_COMMAND);	/* Clear interrupt condition */
 	if(mfm_status & (STAT_DER|STAT_ABN)) {
 		printk("seek failed\n");
 		MFM_DRV_PARAM.cylinder = NEED_2_RECAL;
@@ -548,23 +749,35 @@
 
 static void mfm_specify (void)
 {
+  /* IDEA2 seems to work better - its what RiscOS sets my
+  disc to - on its SECOND call to specify! */
+#define IDEA2
 	unsigned char cmdb[16];
 	printk("specify...\n");
-	cmdb[0] = 0x1F;
-	cmdb[1] = 0xC3;
-	cmdb[2] = 0x16;
-	cmdb[3] = 0x02;
-	cmdb[4] = 0xFC | ((MFM_DRV_PARAM.nocylinders - 1) >> 8);
-	cmdb[5] = MFM_DRV_PARAM.nocylinders - 1;
-	cmdb[6] = MFM_DRV_PARAM.noheads - 1;
-	cmdb[7] = MFM_DRV_PARAM.nosectors - 1;
-	cmdb[8] = 0xA9;
-	cmdb[9] = 0x0A;
-	cmdb[10]= 0x0D;
-	cmdb[11]= 0x0C;
-	cmdb[12]= (MFM_DRV_PARAM.precompcylinder - 1) >> 8;
+	cmdb[0] = 0x1F; /* OM0 - !SECT,!MOD,!DIF,PADP,ECD,CRCP,CRCI,ACOR */
+	cmdb[1] = 0xC3; /* OM1 - DTM,BRST,!CEDM,!SEDM,!DERM,0,AMEX,PSK */
+#ifndef IDEA2
+	cmdb[2] = 0x16; /* OM2 - SL - step pulse low */
+#else
+	cmdb[2] = 0; /* OM2 - SL - step pulse low */
+#endif
+	cmdb[3] = 0x02; /* Connected unit list */
+	cmdb[4] = 0xFC | ((MFM_DRV_PARAM.nocylinders - 1) >> 8); /* RW time over/high part of number of cylinders */
+	cmdb[5] = MFM_DRV_PARAM.nocylinders - 1; /* low part of number of cylinders */
+	cmdb[6] = MFM_DRV_PARAM.noheads - 1; /* Number of heads */
+	cmdb[7] = MFM_DRV_PARAM.nosectors - 1; /* Number of sectors */
+#ifndef IDEA2
+	cmdb[8] = 0xA9; /* Step pulse high=21, Record Length=001 (256 bytes) */
+#else
+	cmdb[8] = 0x21; /* Step pulse high=4, Record Length=001 (256 bytes) */
+#endif
+	cmdb[9] = 0x0A; /* gap length 1 */
+	cmdb[10]= 0x0D; /* gap length 2 */
+	cmdb[11]= 0x0C; /* gap length 3 */
+  /* DAG: Note my data sheet shows precomp and low current the other way around */
+	cmdb[12]= (MFM_DRV_PARAM.precompcylinder - 1) >> 8; /* pre comp cylinder */
 	cmdb[13]= MFM_DRV_PARAM.precompcylinder - 1;
-	cmdb[14]= (MFM_DRV_PARAM.lowcurrentcylinder - 1) >> 8;
+	cmdb[14]= (MFM_DRV_PARAM.lowcurrentcylinder - 1) >> 8; /* Low current cylinder */
 	cmdb[15]= MFM_DRV_PARAM.lowcurrentcylinder - 1;
 
 	issue_command(CMD_SPC, cmdb, 16);
@@ -574,20 +787,24 @@
 static void mfm_seek (void)
 {
 	unsigned char cmdb[4];
+#ifdef DEBUG
 	printk("seeking...\n");
+#endif
 	if(MFM_DRV_PARAM.cylinder < 0) {
 		cmdb[0] = raw_cmd.dev + 1;
 		cmdb[1] = raw_cmd.head;
 
 		SET_INTR(mfm_recal_intr);
+    printk("mfm_seek: about to call specify\n");
+    mfm_specify(); /* DAG added this */
 		issue_command(CMD_RCLB, cmdb, 2);
 		return;
 	}
-	mfm_specify();
+	/*mfm_specify();*//* DAG took this out */
 	if(MFM_DRV_PARAM.cylinder != raw_cmd.cylinder)
 	{
 		cmdb[0] = raw_cmd.dev + 1;
-		cmdb[1] = raw_cmd.head;
+		cmdb[1] = 0; /* raw_cmd.head; DAG: My data sheet says this should be 0 */
 		cmdb[2] = raw_cmd.cylinder >> 8;
 		cmdb[3] = raw_cmd.cylinder;
 
@@ -600,7 +817,9 @@
 
 static void mfm_initialise (void)
 {
+#ifdef DEBUG
 	printk("init...\n");
+#endif
 	if(raw_cmd.flags & NEED_SEEK)
 		mfm_seek();
 	else
@@ -616,7 +835,84 @@
 		return;
 	}
 	if(uptodate) {
-		end_request (1);
+    /* Apparently worked - lets check bytes left to DMA */
+    if (hdc63463_dataleft!=(PartFragRead_SectorsLeft*256)) {
+      printk("mfm: request_done - dataleft=%d - should be %d\n",hdc63463_dataleft,PartFragRead_SectorsLeft*256);
+      end_request (0);
+    } else {
+      /* Potentially this means that we've done; but we might be doing
+         a partial access, (over two cylinders) or we may have a number
+         of fragments in an image file.  First lets deal with partial accesss
+      */
+      if (PartFragRead) {
+        /* Yep - a partial access */
+        CURRENT->buffer+=PartFragRead*256; /* Increment pointer to write */
+
+        /* and issue the remainder */
+        issue_request(MINOR(CURRENT->rq_dev),PartFragRead_RestartBlock,PartFragRead_SectorsLeft,CURRENT);
+        return;
+      };
+
+      /* ah well - perhaps there is another fragment to go */
+
+      /* Increment pointers/counts to start of next fragment */
+      CURRENT->nr_sectors-=frag_len[frag_pos];
+      CURRENT->sector+=frag_len[frag_pos];
+      CURRENT->buffer+=frag_len[frag_pos]*512;
+
+      if (CURRENT->nr_sectors>0) {
+        unsigned int dev,block,nsect;
+        dev=MINOR(CURRENT->rq_dev);
+
+        printk("mfm: Now about to issue fragment %d\n",frag_pos+1);
+        /* OK - time to issue another fragment */
+        /* Increment the place where we are going to store the data */
+        /* Move onto the next fragment */
+        frag_pos++;
+
+        /* But there is a possibility that we are actually going to have to
+           ask for some more fragments */
+        if (frag_pos>=MAX_FRAGS)
+        {
+          printk("mfm: Getting another block of fragments\n");
+          block=CURRENT->sector*2;
+          block+=mfm[dev].start_sect;
+          nsect=CURRENT->nr_sectors*2;
+          if (!image_file_check(CURRENT->rq_dev,CURRENT->cmd))
+          {
+            end_request(0);
+            /* Should I initiate another request here? */
+            return;
+          }
+          frag_count=image_file_map(CURRENT->rq_dev,block/2,nsect/2,MAX_FRAGS,frag_start,frag_len);
+          if (!frag_count)
+          {
+            end_request(0);
+            /* Should I initiate another request here? */
+            return;
+          };
+          frag_pos++;
+        }; /* More fragments ? */
+
+        block=frag_start[frag_pos]*2;
+        frag_sectors=nsect=frag_len[frag_pos]*2;
+
+        /* and issue it */
+        issue_request(dev,block,nsect,CURRENT);
+      } else {
+        /* No - its the end of the line */
+        end_request (1);
+
+#ifdef DEBUG
+        printk("request_done: About to mfm_request\n");
+#endif
+        /* Next one please */
+        mfm_request(); /* Moved from mfm_rw_intr */
+#ifdef DEBUG
+        printk("request_done: returned from mfm_request\n");
+#endif
+      }; 
+    };
 	}
 	else {
 		end_request (0);
@@ -628,6 +924,7 @@
 	int i;
 	printk("error detected... status = ");
 	print_status();
+  /*panic("mfm error");*/ /* DAG tmp */
 	(*errors) ++;
 	if(*errors > MFM_DRV_PARAM.errors.abort)
 		cont->done(0);
@@ -637,6 +934,7 @@
 
 static void rw_interrupt(void)
 {
+  printk("rw_interrupt\n");
 }
 
 static struct cont rw_cont ={
@@ -646,62 +944,64 @@
 	request_done
 };
 
-static void mfm_request (void)
+/*
+ * Actually gets round to issuing the request - note everything at this
+ * point is in 256 byte sectors not Linux 512 byte blocks
+ */
+static void issue_request (int dev, unsigned int block, unsigned int nsect,
+                           struct request *current)
 {
-	unsigned int dev, block, nsect, track;
+    int track,start_head,start_sector;
+    int sectors_to_next_cyl;
 
-	if(CURRENT && CURRENT->dev < 0)
-		return;
+		dev >>= 6;
 
-	while(1){
-		sti();
+		track = block / mfm_info[dev].sectors;
+    start_sector=block % mfm_info[dev].sectors;
+    start_head=track % mfm_info[dev].heads;
 
-		INIT_REQUEST;
-		dev = MINOR(CURRENT->dev);
-		block = CURRENT->sector;
-		nsect = CURRENT->nr_sectors;
+    /* First get the number of whole tracks which are free before the next
+    track */
+    sectors_to_next_cyl=(mfm_info[dev].heads-(start_head+1))*mfm_info[dev].sectors;
+    /* Then add in the number of sectors left on this track */
+    sectors_to_next_cyl+=(mfm_info[dev].sectors-start_sector);
 
-		if(dev >= (mfm_drives << 6) ||
-		    block >= mfm[dev].nr_sects || ((block+nsect) > mfm[dev].nr_sects)) {
 #ifdef DEBUG
-			if(dev >= (mfm_drives << 6))
-				printk("mfm: bad minor number: device=0x%04x\n", CURRENT->dev);
-			else
-				printk("mfm%c: bad access: block=%d, count=%d\n", (dev>>6)+'a',
-					block, nsect);
+    printk("issue_request: mfm_info[dev].sectors=%d track=%d\n",mfm_info[dev].sectors,track);
 #endif
-			end_request(0);
-			continue;
-		}
-		block += mfm[dev].start_sect;
-
-		if(CURRENT->cmd != READ && CURRENT->cmd != WRITE)
-		{
-			printk("unknown mfm-command %d\n", CURRENT->cmd);
-			end_request(0);
-			continue;
-		}
 
-		dev >>= 6;
-
-		track = block / mfm_info[dev].sectors;
 		raw_cmd.flags		= NEED_SEEK;
 		raw_cmd.dev		= dev;
-		raw_cmd.sector		= block % mfm_info[dev].sectors;
-		raw_cmd.head		= track % mfm_info[dev].heads;
+		raw_cmd.sector		= start_sector;
+		raw_cmd.head		= start_head;
 		raw_cmd.cylinder	= track / mfm_info[dev].heads;
 		raw_cmd.cmdtype 	= CURRENT->cmd;
 		raw_cmd.cmdcode 	= CURRENT->cmd == WRITE ? CMD_WD : CMD_RD;
-		raw_cmd.cmddata[0]	= dev;
+		raw_cmd.cmddata[0]	= dev+1; /* DAG: +1 to get US */
 		raw_cmd.cmddata[1]	= raw_cmd.head;
 		raw_cmd.cmddata[2]	= raw_cmd.cylinder >> 8;
 		raw_cmd.cmddata[3]	= raw_cmd.cylinder;
 		raw_cmd.cmddata[4]	= raw_cmd.head;
 		raw_cmd.cmddata[5]	= raw_cmd.sector;
-		raw_cmd.cmddata[6]	= nsect >> 8;
-		raw_cmd.cmddata[7]	= nsect;
+    if (nsect<=sectors_to_next_cyl) {
+      raw_cmd.cmddata[6]	= nsect >> 8;
+      raw_cmd.cmddata[7]	= nsect;
+      PartFragRead=0; /* All in one */
+      PartFragRead_SectorsLeft=0; /* Must set this - used in DMA calcs */
+    } else {
+      raw_cmd.cmddata[6]	= sectors_to_next_cyl >> 8;
+      raw_cmd.cmddata[7]	= sectors_to_next_cyl;
+      PartFragRead=sectors_to_next_cyl; /* only do this many this time */
+      PartFragRead_RestartBlock=block+sectors_to_next_cyl; /* Where to restart from */
+      PartFragRead_SectorsLeft=nsect-sectors_to_next_cyl;
+    };
 		raw_cmd.cmdlen		= 8;
 
+    /* Setup DMA pointers */
+    hdc63463_dataptr=CURRENT->buffer;
+    hdc63463_dataleft=nsect*256; /* Better way? */
+
+
 #ifdef DEBUG
 		printk("mfm%c: %sing: CHS=%d/%d/%d, sectors=%d, buffer=0x%08lx (%p)\n",
 			raw_cmd.dev+'a', (CURRENT->cmd == READ)?"read":"writ",
@@ -713,12 +1013,113 @@
 		errors = &(CURRENT->errors);
 		mfm_tq.routine = (void (*)(void *))mfm_initialise;
 		queue_task(&mfm_tq, &tq_timer);
+}; /* issue_request */
+
+static void mfm_request (void)
+{
+	unsigned int dev, block, nsect;
+
+#ifdef DEBUG
+  printk("mfm_request CURRENT=%p\n",CURRENT);
+#endif
+	if(CURRENT && CURRENT->rq_dev < 0) {
+    printk("mfm_request: exit due to (CURRENT && CURRENT->rq_dev < 0)\n");
+		return;
+  };
+
+	while(1){
+#ifdef DEBUG
+    printk("mfm_request: loop start\n");
+#endif
+    /* DAG: I wonder if there wshould be a store flags here? */
+		sti();
+
+#ifdef DEBUG
+    printk("mfm_request: before INIT_REQUEST\n");
+#endif
+		INIT_REQUEST;
+#ifdef DEBUG
+    printk("mfm_request: before arg extraction\n");
+#endif
+		dev = MINOR(CURRENT->rq_dev);
+		block = CURRENT->sector;
+		nsect = CURRENT->nr_sectors;
+
+#ifdef DEBUG
+    printk("mfm_request: raw vals: dev=%d block=%d nsect=%d\n",dev,block,nsect);
+#endif
+
+    /* DAG: Linux doesn't cope with this - even though it has an array telling
+       it the hardware block size - silly */
+    block *= 2; /* Now in 256 byte sectors */
+    nsect *= 2; /* Ditto */
+
+		if(dev >= (mfm_drives << 6) ||
+		    block >= (mfm[dev].nr_sects*2) || ((block+nsect) > (mfm[dev].nr_sects*2))) {
+      printk("mfm: oops dev=0x%04x mfm_drives=%d block=%d mfm[dev].nr_sects=%d nsect=%d\n",
+             dev,mfm_drives,block,mfm[dev].nr_sects,nsect);
+			if(dev >= (mfm_drives << 6))
+				printk("mfm: bad minor number: device=0x%04x\n", CURRENT->rq_dev);
+			else
+				printk("mfm%c: bad access: block=%d, count=%d\n", (dev>>6)+'a',
+					block, nsect);
+			end_request(0);
+			continue;
+		}
+		block += mfm[dev].start_sect;
+
+    if (dev & 0x3f)
+    {
+      /* map sectors block to block+nsect to frags.
+       */
+      if (!image_file_check(CURRENT->rq_dev,CURRENT->cmd)) continue;
+      frag_count = image_file_map(CURRENT->rq_dev,block/2,nsect/2,MAX_FRAGS,frag_start,frag_len);
+      if(!frag_count)
+      {
+        continue;
+      }
+      block=frag_start[0]*2;
+      frag_sectors=nsect=frag_len[0]*2;
+      frag_pos=0;
+    } else {
+      /* OK - its not an image file - lets just push it through */
+      frag_pos=0;
+      frag_count=1;
+      frag_sectors=nsect;
+      frag_len[frag_pos]=frag_sectors/2;
+      if (CURRENT->cmd==WRITE)
+      {
+         /* Stop writing to the raw drive */
+         printk("mfm%d: attempted write on protected drive\n",dev);
+         end_request(0);
+         continue;
+      };
+    }; /* image file/normal if */
+#ifdef DEBUG
+    printk("mfm_request: block after offset=%d\n",block);
+#endif
+
+		if(CURRENT->cmd != READ && CURRENT->cmd != WRITE)
+		{
+			printk("unknown mfm-command %d\n", CURRENT->cmd);
+			end_request(0);
+			continue;
+		}
+
+    issue_request(dev,block,nsect,CURRENT);
+
 		break;
 	}
+#ifdef DEBUG
+  printk("mfm_request: Dropping out bottom\n");
+#endif
 }
 
 static void do_mfm_request (void)
 {
+#ifdef DEBUG
+  printk("do_mfm_request: about to mfm_request\n");
+#endif
 	mfm_request();
 }
 
@@ -726,6 +1127,7 @@
 {
 	printk("mfm: unexpected interrupt - status = ");
 	print_status();
+  while(1);
 }
 
 static void mfm_interrupt_handler (int unused, struct pt_regs *regs)
@@ -733,9 +1135,14 @@
 	int i;
 	void (*handler)(void) = DEVICE_INTR;
 
+#ifdef DEBUG
+  printk("mfm_interrupt_handler (handler=0x%p)\n",handler);
+#endif
 	CLEAR_INTR;
 	mfm_status = inw(MFM_STATUS);
 
+  /* If CPR (Command Parameter Reject) and not busy it means that the command
+     has some return message to give us */
 	if((mfm_status & (STAT_CPR|STAT_BSY)) == STAT_CPR)
 	{
 		int len = 0;
@@ -748,14 +1155,22 @@
 		}
 	}
 
-	outw(CMD_RCAL, MFM_COMMAND);	/* Clear interrupt condition */
 
 	if(!handler) {
+    outw(CMD_RCAL, MFM_COMMAND);	/* Clear interrupt condition */
 		mfm_unexpected_interrupt();
 		return;
 	}
-	mfm_tq.routine = (void (*)(void *))handler;
-	queue_task_irq(&mfm_tq, &tq_timer);
+	/*mfm_tq.routine = (void (*)(void *))handler;
+	queue_task_irq(&mfm_tq, &tq_timer); */
+  handler();
+}
+
+/* DAG: Called presumably to accept command line parameters */
+/* Ignore for the moment! */
+void mfm_setup(char *str, int *ints)
+{
+  return;
 }
 
 #ifdef MODULE
